*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.




*-------------------------------------------------------------------------------------------------------------
*---------------------------------------- calculate color amplitudes -----------------------------------------
*-------------------------------------------------------------------------------------------------------------



*--- expad f into traces of t's (there can be at most GORD f tensors)
#do i=1,`GORD' 
*--- we use f^{abc} = 2 i Tr(t^c t^b t^a - t^a t^b t^c)
once f(bb1?,bb2?,bb3?) = 2*i_*(t(bb3,AA`i',BB`i')*t(bb2,BB`i',CC`i')*t(bb1,CC`i',AA`i') - t(bb1,AA`i',BB`i')*t(bb2,BB`i',CC`i')*t(bb3,CC`i',AA`i'));
#enddo;

*--- replace a product of adjoint matrices t^a_{ij} t^a_{kl} = 1/2 (delta_{il} delta_{jk} - 1/Nc delta_{ij} delta_{kl})
repeat
id t(bb?,AA1?,AA2?)*t(bb?,AA3?,AA4?) = 1/2*(d_(AA1,AA4)*d_(AA2,AA3) - 1/`Nc' * d_(AA1,AA2)*d_(AA3,AA4));

*--- use  Tr(t^a t^b) = 1/2 delta{ab}
repeat
id t(bb1?,AA1?,AA2?)*t(bb2?,AA2?,AA1?) = 1/2 * d_(bb1,bb2);
*--- use tracelessness of generators
id t(bb1?,AA1?,AA1?) = 0;

#do i=1,`GORD'
sum AA'i', BB'i', CC'i';
#enddo

renumber;

#call print
.sort: Color A;
*-------------------------------------------------------------------------------------------------------------

*--- put together chains of generators
cf chaint;

repeat
id t(cc1?,AA1?,AA2?)*t(cc2?,AA2?,AA3?) = chaint(cc1,cc2,AA1,AA3);

repeat
id chaint(?a1,AA1?,AA2?)*t(?a2,AA2?,AA3?) = chaint(?a1,?a2,AA1,AA3);

repeat
id chaint(?a1,AA1?,AA2?)*chaint(?a2,AA2?,AA3?) = chaint(?a1,?a2,AA1,AA3);

id chaint(?a,AA?,AA?) = Tr(?a);

id fun(ARG?) = ARG;
b Den, Tr;
#call print
.sort: Color B;
*-------------------------------------------------------------------------------------------------------------


*--- simplify color amplitudes
#call info(Simplifying color amplitudes...)
collect fun;
.sort: Color C;

#do l=1,`TOTSIMPDEPTH'
#do l=1,`MOMSIMPDEPTH'
#call SimplifyMom(fun)
#enddo
#if `USEINVSIMP' == 1
#call SimplifyInv(fun)
#endif
.sort: Color D;

id fun(0) = 0;

#call print
.sort: Color E;
#enddo
*-------------------------------------------------------------------------------------------------------------


