*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.




*-------------------------------------------------------------------------------------------------------------
*------------------------------------ utilize creation/anihilation operators ---------------------------------
*-------------------------------------------------------------------------------------------------------------




*--- make field operators noncommuting again
f hold; *>> auxiliary function that prevents from producing too many internal variables
id [:](?a1,A1(?b1)) = [:](?a1,A(?b1));
repeat id [:](?a1,A1(?b1),ARG?) = [:](?a1,A(?b1)*ARG);
id [:](ARG?) = [:]*ARG;

#call print
#$NINTMOM = 1; *>> number of internal momentum labels
.sort: c/a A;
*-------------------------------------------------------------------------------------------------------------


*--- expand normal ordered field operators into creation/anihilation operators
 $cnt = 1;
 repeat;
  if ( match(A(x?,alph?,jj?,ARG?)) ); *>> somehow it needs to match all args...
   once A(x?,alph?,jj?,?a) = hold(a(pf($cnt),jj)*ecf(pf($cnt),alph)*exp(x,-pf($cnt)) 
                          + ac(pf($cnt),jj)*ef(pf($cnt),alph)*exp(x,pf($cnt))); *>> pf(i) is auxiliary notation for a momentum
   $cnt = $cnt + 1;
  endif;
  if ( $NINTMOM < $cnt );
  $NINTMOM = $cnt;
  endif;
 endrepeat;

 id hold(ARG?) = ARG;

#call print
moduleoption noparallel;
.sort: c/a B;
#$NINTMOM = {`$NINTMOM'-1};
*-------------------------------------------------------------------------------------------------------------


*--- place creation/anihilation operators under [:]

repeat; 
 id [:](?b)*a(?c) = [:](?b,a(?c));
 id [:](?b)*ac(?c) = [:](?b,ac(?c));
endrepeat;

#call print
.sort: c/a C;
*-------------------------------------------------------------------------------------------------------------


*--- express external kets in terms of creation/anihilation operators

if ( match( [|0>] ) );
repeat id [|0>]*[:](?a2) = [:](?a2)*[|0>];
else;
repeat id [|g>](?a1)*[:](?a2) = [:](?a2)*[|g>](?a1);
multiply right [|0>];
endif;
id [|g>](p?,cc?) = ac(p,cc);
id [<g|](p?,cc?) = a(p,cc);
if ( match( [<0|] ) );
else;
multiply left [<0|];
endif;

#call print
.sort: c/a D;
*-------------------------------------------------------------------------------------------------------------



*--- apply the normal ordering
repeat id [:](?a1,a(?b1),ac(?b2),?a2) = [:](?a1,ac(?b2),a(?b1),?a2);
repeat id [:](?a,ARG?) = [:](?a)*ARG;
id [:] = 1;

#call print
.sort: c/a E;
*-------------------------------------------------------------------------------------------------------------



*--- apply commutation relations
repeat;
 id a(?b1,cc1?)*ac(?b2,cc2?) = ac(?b2,cc2)*a(?b1,cc1) + delta(?b1,?b2)*d_(cc1,cc2);
 id a(?b)*[|0>] = 0;
 id [<0|]*ac(?b) = 0;
endrepeat;
id [<0|]*[|0>] = 1;

#call print
.sort: c/a F;
*-------------------------------------------------------------------------------------------------------------


#procedure pfpi(i)
*--- replace functional representation for the internal momenta to vectors
 id pf(`i') = p`i';
 id pf(`i',alph?) = p`i'(alph);
#endprocedure

*--- utilize deltas from commutation relations

*--- exchange momenta in functional form to vectors
*--- unfortunately this cannot be done using replace_
argument;
#do l=1,`$NINTMOM'
#call pfpi(`l')
#enddo
endargument;

symmetrize delta;

repeat;
term;
once delta(v1?,v2?) = replace_(v2,v1);
sort;
endterm;
endrepeat;

#call print
.sort: c/a G;
*-------------------------------------------------------------------------------------------------------------


