*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.



*-------------------------------------------------------------------------------------------------------------
*-------------------------- declarations of the variables (most of them) -------------------------------------
*-------------------------------------------------------------------------------------------------------------



*--- color group structure constants and generators
T f(antisymmetric), t;

*--- trace of color matrices
cf Tr(cyclesymmetric);

*--- Lorentz indices
auto i mu=`NDIM', nu=`NDIM', alph=`NDIM', bet=`NDIM', gam=`NDIM', omeg=`NDIM';

*--- color indices
i cc, <cc1=0>,...,<cc100=0>; *>> external adjoint color
auto i bb=`Na', dd=`Na', jj=`Na', kk=`Na', ll=`Na', ss=`Na', rr=`Na', hh=`Na'; *>> internal adjoint color
auto i AA=`Nc', BB=`Nc', CC=`Nc', DD=`Nc', EE=`Nc', FF=`Nc', GG=`Nc'; *>> internal fundamental colour indices

*--- Yang-Mills interaction
f [Exp(-i*S_YM)], SI;

*--- Wilson line operators
f W;

*--- vacuum states
f [|0>], [<0|];

*--- external gluon states
f [|g>], [<g|];

*--- gluon field
f A;
cf A1;  *>> this one is commuting (auxiliary)

*--- time ordering
f T;

*--- normal ordering
f [:], [::];

*--- gluon propagator
cf S, S1;

*--- polarization tensor (in functional form)
auto cf D;

*--- standard functions
cf exp, Exp;

*--- polarization vectors
auto v e, ec; 
auto cf ef, ecf; *>> in functional form

*--- creation/annihilation operators
f a, ac;

*--- Dirac deltas
cf delta, delta1, deltap;

*--- denominators
cf den, Den, deneik;

*--- external momenta
v k1,...,k100; *>> the order of declaration matters here!

*--- internal momenta
auto v p, q;
auto cf pf; *>> in functional form

*--- space-time points
auto v x, y, z, w;

*--- gauge vectors, or gauge-link directions;
auto v n;

*--- strong coupling constant
auto s g;

*--- auxiliary variables
auto s ARG;
auto cf fun;
auto v v;

