*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.




*-------------------------------------------------------------------------------------------------------------
*--------------------------------- produce and utilize momentum conservation deltas --------------------------
*-------------------------------------------------------------------------------------------------------------


*--- get exponentials together
repeat id exp(x?,?a1,q?)*exp(x?,?a2,p?) = exp(x,?a1,?a2,q,p);

*--- integrate over spacetime
repeat id exp(x?,?a) = delta(?a);
symmetrize delta;
.sort: deltas A;

*--- integrate over internal momenta
set intmoms: p1,...,p`MAXINTMOM'; *>> set of internal momenta

repeat;

 repeat id delta(?a1,0,?a2) = delta(?a1,?a2);

 if ( match(once delta(?a1,p?intmoms,?a2)) || match(once delta(?a1,-p?intmoms,?a2)) );

  if ( match(once delta(?a1,p?intmoms$match1,?a2)) );
   $match = $match1;
  elseif ( match(once delta(?a1,-p?intmoms$match2,?a2)) );
   $match = -$match2;
  endif;
  
   once delta(?a1,$match,?a2) = delta1($match,delta(?a1,?a2));

 argument delta1,2;
  id delta = 0;
  repeat id delta(v1?,v2?,?a) = delta(?a,v1+v2);
  id delta(v?) = -v;
 endargument;

 if ( match(delta1($match,0)) );
  $repl = 0;
  id $match = 0;
  argument;
   id $match = 0;
  endargument;
  id delta1(0,0) = 1;
 else;
  once delta1($match,v1?$repl) = delta(0);
  id $match = $repl;
  argument;
   id $match = $repl;
  endargument;
 endif;

splitarg delta;

symmetrize delta;

endif;

endrepeat;

id delta = 1;
id delta(<-k1>,...,<-k`NFS'>) = delta(k1,...,k`NFS');
#call print
moduleoption local $match1, $match2, $match, $repl;
.sort: deltas C;
*-------------------------------------------------------------------------------------------------------------


*--- make eikonal propagator a true denominator and get rid of transversal delta (deltap)
id deneik(v1?,v2?) = deneik(v1.v2);
id deltap(v1?,v2?) = 1;
argument deneik;
id,many,ARG1?^ARG2? = 1;
endargument;
id deneik(ARG?) = Den(ARG);

*--- check if the delta functions were utilized correctly
if ( ( match(delta(k1,...,k`NFS')) ) == 0 );
exit "ERROR: sth wrong with delta functions.";
else;
id delta(?a) = 1;
endif;
*id delta(k1,...,k`NFS') = 1;
*id delta(?a) = 0;
#call print
.sort: deltas D;
*-------------------------------------------------------------------------------------------------------------
