*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.




*-------------------------------------------------------------------------------------------------------------
*------------------------------------------------ Wilson lines -----------------------------------------------
*-------------------------------------------------------------------------------------------------------------


*--- positions along the gauge link direction
auto s sl;

*=============================================================================================================
#procedure Wilsonline(K)
*--- expands Wilson line in gauge fields to necessary order
*--- the fields belonging to one Wilson line are normal ordered, i.e. there will be no Wick contraction between them

#define LABEL0 ""

id W(v?,cc?,n?,`K') = exp(x`K',v)*(
#do l=1,{`NFS'-1}
#redefine LABEL "{`LABEL'+1}"
#redefine LABEL0 "`LABEL'"
   + t(cc,EE`LABEL0',FF`LABEL')*(
#do k=1,`l'
                  i_*g*A(x`K'+sl`K'`LABEL'*n,gam`LABEL',hh`LABEL',`LABEL0')*n(gam`LABEL')*t(hh`LABEL',FF`LABEL',FF{`LABEL'+1})
#if ( `k' < `l' )
                *
#endif
#redefine LABEL "{`LABEL'+1}"
#enddo
                 )*d_(EE`LABEL0',FF{`LABEL'})
#enddo
                 )/g;

#undefine LABEL0

#endprocedure
*=============================================================================================================



*=============================================================================================================
#procedure Wilsonlines
#do k=1,`NOFF'
*--- store the condition that k.n = 0 (k -- "momentum" of the gauge link, n -- "direction" of the gauge link)
id W(v?$wlinemom`k',cc?,n?$wlinedir`k',`k') = W(v,cc,n,`k');

*--- expand Wilson line in gauge fields
#call Wilsonline(`k')
#enddo
#endprocedure
*=============================================================================================================
