*    Copyright (C) 2013 Piotr Kotko
*
*    This file is part of OGIME
*
*    OGIME is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.




*-------------------------------------------------------------------------------------------------------------
*-------------------------------------- insert gluon and eikonal propagators ---------------------------------
*-------------------------------------------------------------------------------------------------------------



*--- insert gluon propagatros with momenta in functional form
#$NINTMOM = 1;
$cnt = 1;

repeat;
 if ( match(S(?a)) );
  once S(x?,y?,mu?,nu?,?a) = i_*exp(x,-pf($cnt))*exp(y,pf($cnt))*S1(pf($cnt))*D(pf($cnt),mu,nu);
  $cnt = $cnt+1;
  symmetrize D, 2,3;
 endif;
 if ( $NINTMOM < $cnt );
  $NINTMOM = $cnt;
 endif;
endrepeat;

moduleoption noparallel;
.sort: propagators A;
#$NINTMOM = {`$NINTMOM'-1};
*-------------------------------------------------------------------------------------------------------------



*---  exchange internal momenta in functional form to vectors
*--- unfortunately this cannot be done using replace_
*--- see "creation_anihilation.frm" for pfpi(i) procedure
#do i=1,`$NINTMOM'
#call pfpi(`i')
 argument;
#call pfpi(`i')
 endargument;
.sort: propagators B;
#enddo
*-------------------------------------------------------------------------------------------------------------



*--- relabel momenta q`i' to p`i'; then all internal momenta are p`i'
*--- the number of q`i's is `QLABEL' (see "interaction.frm")
#define MAXINTMOM "{`$NINTMOM'+1}"

multiply replace_(q1,p`MAXINTMOM'
#do i=2,`QLABEL'
#redefine MAXINTMOM "{`MAXINTMOM'+1}"
                              ,q`i',p`MAXINTMOM'
#enddo
                                             );

#call print
.sort: propagators C;
*-------------------------------------------------------------------------------------------------------------



*--- calculate eikonal propagators

*--- first split exponents to space-time part and "gauge link part"
splitarg exp,1;
id exp(v1?,v2?,v3?) = exp(v1,v3)*exp(v2,v3);
*print;
.sort: eikonal A;

#do K=1,`NOFF'
argument exp,1;
#do k=1,`LABEL'
if ( match( sl`K'`k' ) );
$SL`K'`k' = term_; *>> $SL`A'`B' stores gauge link position variables
endif;
#enddo
endargument;
#enddo
.sort: eikonal B;

*--- place "gauge link exponent" in Exp instead of exp
#do K=1,`NOFF'
#do k=1,`LABEL'
id exp(`$SL`K'`k'',v?) = Exp(`$SL`K'`k'',v);
#enddo
#enddo
.sort: eikonal C;

*--- calculate eikonal propagator along the path
#do K=1,`NOFF'
#do k=`LABEL',2,-1
id Exp(`$SL`K'`k'',v1?)*Exp(`$SL`K'{`k'-1}',v2?) = Exp(`$SL`K'{`k'-1}',v2+v1)*deneik(`$SL`K'`k'',v1)*(-i_);
#enddo
#enddo

id Exp(v1?,v2?) = deltap(v1,v2);

#call print
.sort: eikonal D;
*-------------------------------------------------------------------------------------------------------------
