#!/bin/bash

# read user settings
source config.cfg

# create directory for temporary FORM files
if [ ! -d $FORM_TMP_DIR_ ]; then
mkdir $FORM_TMP_DIR_
fi


# check if "output" directory exists; create of not
if [ ! -d $OUTPUT_DIR_ ]; then
mkdir $OUTPUT_DIR_
fi

# the first parameter to the script is user input file to be used; it should be given without extension ".in"
# check if it exists
if [ ! -f $INPUT_DIR_/$1".in" ]; then
echo "ERROR: the input file \"$1.in\" does not exist in $INPUT_DIR_ !"
echo "Note the extension for the input files \".in\" has to be dropped out."
exit 1
fi


# run FORM with passing the name of the user input file with matrix element (with location given in INPUT_DIR_)
# the second argument is optional and passed to FORM
$FORM -d INPUT_FILE=$1 -d INPUT_DIR=$INPUT_DIR_ -d OUTPUT_DIR=$OUTPUT_DIR_ -t $FORM_TMP_DIR_ -s . -p ./core $2 ./core/main.frm

# place the FORM *.sav output files inside the output directory
if [ -f $1".sav" ]; then
mv $1".sav" $OUTPUT_DIR_
fi

