#!/bin/bash

# read user settings
source config.cfg

# create directory for temporary FORM files
if [ ! -d $FORM_TMP_DIR_ ]; then
mkdir $FORM_TMP_DIR_
fi


# the first parameter to the script is FORM *.sav output; it should be given without extension ".sav"
# check if it exists and copy it to the main directory
if [ ! -f $OUTPUT_DIR_/$1".sav" ]; then
echo "ERROR: the FORM output file \"$1.sav\" does not exist in $OUTPUT_DIR_ !"
echo "Note the extension \".sav\" has to be dropped out."
exit 1
else
cp $OUTPUT_DIR_/$1".sav" .
fi

# check if the second argument is given
if [ -z "$2" ]; then
echo "ERROR: the second argument should be a number indicating which external polarization vector should be replaced by the momentum"
exit 1
fi

# run FORM with passing the name of the output file (with location given in OUTPUT_DIR_)
# the second argument indicates the number of external polarization vector to be replaced by the momentum
$FORM -d OUTPUT_DIR=$OUTPUT_DIR_ -d OUTPUT_FILE=$1 -d REPL_NO=$2 -t $FORM_TMP_DIR_ -s . -p ./core -q ./core/check_gauge_invariance.frm

# remove the copy of the *.sav file
if [ -f $OUTPUT_DIR_/$1".sav" ]; then
rm -r $1".sav"
fi


